;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;True LevelASM Code lies ahead.
;If you are too lazy to search for a level
;Use CTRL+F. The format is as following:
;levelx - Levels 0-F
;levelxx - Levels 10-FF
;levelxxx - Levels 100-1FF
;Should be pretty obvious...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

level122:
	JSR Layer3TideFix
	JSR CeilingGenerator
	RTS
level1A6:
	RTS
level1A7:
	RTS
level1A8:
	RTS
level1A9:
	RTS
level1AA:
	RTS
level1AB:
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Transparent Layer 1 Water ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TransparentLayer1Water:
	REP #%00010000		; 16-bit X/Y
	LDA.b #%00000001	; \ 
	STA.w $4340		;  | HDMA for
	LDA.b #$2C		;  | TM/TS
	STA.w $4341		;  |
	LDY.w #.TL1WTbl		;  |
	STY.w $4342		;  |
	LDA.b #.TL1WTbl>>16		;  |
	STA.w $4344		; /
	LDA.b #%00000001	; \ 
	STA.w $4350		;  | HDMA for
	LDA.b #$2E		;  | TMW/TSW
	STA.w $4351		;  | (not sure if
	LDY.w #.TL1WTbl		;  | this is needed)
	STY.w $4352		;  |
	LDA.b #.TL1WTbl>>16		;  |
	STA.w $4354		; /
	LDA.b #%00000000	; \ 
	STA.w $4360		;  | HDMA for
	LDA.b #$31		;  | CGADSUB
	STA.w $4361		;  |
	LDY.w #.TL1WTbl2		;  |
	STY.w $4362		;  |
	LDA.b #.TL1WTbl2>>16	;  |
	STA.w $4364		; /
	LDA.b #%01110000	; \ enable
	TSB.w $0D9F		; / HDMA
	SEP #%00010000		; 8-bit X/Y
.TL1WRtn	RTS
.TL1WTbl	db $25			; for first #$25 scanlines
	db %00010111		; TM
	db %00000000		; TS
	db $5A			; for next #$5A scanlines
	db %00010011		; TM
	db %00000100		; TS
	db $30			; ******THIS VALUE +#$80 IS HOW MANY SCANLINES DOWN THE WATER IS******
	db %00010011		; TM
	db %00000100		; TS
	db $80			; for next scanline (and all after)
	db %00000001		; TM
	db %00010110		; TS
	db $00
.TL1WTbl2	db $7F			; for first #$7F scanlines
	db %00100000		; CGADSUB
	db $30			; ******YOU MUST CHANGE THIS VALUE TO THE EXACT SAME THING******
	db %00100000		; CGADSUB
	db $80			; for next scanline (and all after)
	db %00100001		; CGADSUB


;;;;;;;;;;;;;;;;;;;;;;;;;
;; Transparent Layer 3 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;

TransparentLayer3:
	LDA $40		;\
	ORA #$04	; |Set the layer 3 bit of CGADDSUB
	STA $40		;/
	LDA #$13	;\
	STA $212d	;/add some layer to the subscreen
	RTS		;Return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Layer 3 Tide Vertical-Scrolling Fix ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	HEIGHT_DIFF = $0080	; $C0 - layer 3 Yposition ( ? + H = $C0 )
				; default low tide Yposition is 40 ( ? = $0080 )

Layer3TideFix:
	PHP
	REP #%00110100
	LDA $1C			; \
	CMP.w #HEIGHT_DIFF	;  |  compare screen Y position
	BCS VARH		;  |  with $C0 - desired Y
	BCC ZERO		; /
VARH:
	LDA $1C			; \
	SBC.w #HEIGHT_DIFF	;  |  set layer 3 Y
	STA $24			;  |  to $C0 - desired height
	PLP			;  |  if screen Y > or = the value
	RTS			; /

ZERO:
	LDA.w #$0000		; \
	STA $24			;  |  set layer 3 Y to zero
	PLP			;  |  if screen Y < the value
	RTS			; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Off-Screen Ceiling Generator ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CeilingGenerator:
	LDA $97			; mario y (high (next frame))
	BPL CEILING_RETURN	; if not negative, return
	LDY #$00		; load 0 in to Y 
	LDA $19			; powerup
	BEQ CEILING_2		; if small, check for ceiling height as small mario
	LDA $73			; same if ducking
	BNE CEILING_2		; 
	LDY #$01		; otherwise check as big
CEILING_2:
	LDA CEILING_TABLE,y	; if not yet above ceiling threshold...
	CMP $96			; mario y (low)
	BCC CEILING_RETURN	; return
	INC A			; 
	STA $96			; place mario on top of screen
	LDA $7D			; 
	EOR #$FF		; Flip mario y speed
	INC A			;
	CMP #$10		; cap downward speed at 10
	BCC CEILING_1		;
	LDA #$10
CEILING_1:
	STA $7D			; set speed

	;LDA #$01		; play "hit head" sound effect
	;STA $1DF9		;

CEILING_RETURN:
	RTS			; reutrn

CEILING_TABLE:
	db $E8,$F0		; how high above the screen mario can go for small and big mario